package cp;


import cp.db.DB;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;

import java.sql.Statement;

import java.util.Vector;

public class Games extends Vector<Game> {
  private Tournament tournament;
  
  public Games(Tournament tournament) {
    super();
    this.tournament = tournament;
  }

  boolean hasAllResults() {
    for (int i=0; i<size(); i++) {
      Game game = get(i);
      if (!game.hasResult()) {
        return false;
      }
    }
    return true;
  }

  void save(int roundNr) throws SQLException {
    for (int i=0; i<size(); i++) {
      Game game = get(i);
      game.save(roundNr, i+1);
    }
  }

  void load(int roundNr, Players players) throws SQLException, ChessPairerException {
    Connection conn = DB.getConnection();
    Statement s = conn.createStatement();
    String sql = "select * from tournamentgames " +
                 "WHERE tournament = " + tournament.getIndex() + " " + 
                 "AND round = " + roundNr + " " + 
                 "ORDER BY boardnr";
    ResultSet rs = s.executeQuery(sql);
    while (rs.next()) {
      Game game = new Game(this);
      game.load(rs, players);
      add(game);
    }
    s.close();
  }

  public Tournament getTournament() {
    return tournament;
  }

  public void delete(Round round, Game game) throws SQLException {
    this.remove(game);
    game.removeFromPlayers();
    // The boardnr needs to be updated for all games. Delete all games and save them again.
    Connection conn = DB.getConnection();
    Statement s = conn.createStatement();
    String sql = "DELETE from tournamentgames " +
                 "WHERE tournament = " + tournament.getIndex() + " " + 
                 "AND round = " + round.getRoundNr();
    try {
      s.execute(sql);
      save(round.getRoundNr());
      conn.commit();
    }
    catch (SQLException e) {
      conn.rollback();
      throw e;
    }
  }
  
  void setTournament(Tournament tournament) {
    this.tournament = tournament;
    for (int i=0; i<size(); i++) {
      Game game = get(i);
      game.setGames(this);
    }
  }

  public void addToPlayers() {
    for (int i = 0; i < size(); i++) {
      Game game = get(i);
      game.addToPlayers();
    }
  }

  void removeFromPlayers() {
    for (int i=0; i < size(); i++) {
      Game game = get(i);
      game.removeFromPlayers();
    }
  }

  public boolean hasPlayer(Player b) {
    return (getGame(b) != null);
  }

  public Game getGame(Player b) {
    for (int i=0; i < size(); i++) {
      Game game = get(i);
      if (game.getWhitePlayer() == b || game.getBlackPlayer() == b) {
        return game;
      }
    }
    return null;
  }
}
