package cp;

import java.sql.SQLException;

import java.util.Vector;

public class Rounds extends Vector<Round> {
  private Tournament tournament;
  
  public Rounds(Tournament tournament) {
    super();
    this.tournament = tournament;
  }
  
  public void load(int rounds, Players players) throws SQLException, ChessPairerException {
    for (int i=0; i < rounds; i++) {
      Round round = new Round(tournament);
      round.load(i+1, players);
      if (round.isEmpty()) {
        return;
      }
      add(round);
    }
  }
  
  public void delete(int roundNr) throws SQLException {
    Round round = get(roundNr-1);
    if (round != null) {
      round.delete();
      this.remove(round);
    }
  }

  Round getCurrentBergerRound() {
    for (int i=0; i<size(); i++) {
      Round round = get(i);
      if (!round.hasAllResults()) {
        return round;
      }
    }
    return lastElement();
  }

  boolean isFinished() {
    for (int i=0; i<size(); i++) {
      Round round = get(i);
      if (!round.hasAllResults()) {
        return false;
      }
    }
    return true;
  }
}
