package cp.gui;


import cp.ChessPairerException;
import cp.Game;
import cp.Games;
import cp.Player;
import cp.Players;
import cp.Round;

import java.awt.BorderLayout;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import java.awt.Insets;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.sql.SQLException;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class EditPairDialog extends JDialog {
  private JPanel jPanel1 = new JPanel();
  private JPanel jPanel2 = new JPanel();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JButton jButtonOk = new JButton();
  private JButton jButtonCancel = new JButton();
  private GridBagLayout gridBagLayout1 = new GridBagLayout();
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JComboBox jComboBoxWhite = new JComboBox(new ComboBoxSorterModel());
  private JComboBox jComboBoxBlack = new JComboBox(new ComboBoxSorterModel());
  private JLabel jLabel4 = new JLabel();
  private Game game;
  private Players players;

  public EditPairDialog(Round round) {
		Players players = new Players(round.getTournament().getSettings());
    players.addAll(round.getGames().getTournament().getPlayers());
    // Remove all players that plays in a game
		Games games = round.getGames();
    for (int i = 0; i < games.size(); i++) {
			Game game = games.get(i);
      players.removeElement(game.getWhitePlayer());
      players.removeElement(game.getBlackPlayer());
    }
    this.players = players;
    try {
      jbInit();
      jComboBoxWhite.addItem(null);
      jComboBoxBlack.addItem(null);
      for (int i = 0; i < players.size(); i++) {
				Player player = players.get(i);
        jComboBoxWhite.addItem(player);
        jComboBoxBlack.addItem(player);
      }
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void setGame(Game game) {
		this.game = game;
		if (game.getWhitePlayer() != null) {
			jComboBoxWhite.addItem(game.getWhitePlayer());
			jComboBoxBlack.addItem(game.getWhitePlayer());
		}
		if (game.getBlackPlayer() != null) {
			jComboBoxWhite.addItem(game.getBlackPlayer());
			jComboBoxBlack.addItem(game.getBlackPlayer());
		}
		jComboBoxWhite.setSelectedItem(game.getWhitePlayer());
		jComboBoxBlack.setSelectedItem(game.getBlackPlayer());
		this.setTitle("Bord nr " + game.getBoardNr());
	}

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(463, 135));
    this.setModal(true);
    jPanel1.setLayout(gridBagLayout1);
    jButtonOk.setText("Ok");
    jButtonOk.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonOk_actionPerformed(e);
        }
      });
    jButtonCancel.setText("Avbryt");
    jButtonCancel.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonCancel_actionPerformed(e);
        }
      });
    jLabel1.setText("Vit");
    jLabel2.setText("Svart");
    jLabel4.setText("Namn");
    jPanel1.add(jLabel1, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel2, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jComboBoxWhite,
                new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 10), 0, 0));
    jPanel1.add(jComboBoxBlack,
                new GridBagConstraints(2, 1, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 10), 0, 0));
    jPanel1.add(jLabel4, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 10, 0, 10), 0, 0));
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel2.add(jButtonOk, null);
    jPanel2.add(jButtonCancel, null);
    this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
  }

  private void jButtonCancel_actionPerformed(ActionEvent e) {
    setVisible(false);
  }

  private void jButtonOk_actionPerformed(ActionEvent e) {
    if (jComboBoxWhite.getSelectedItem() == jComboBoxBlack.getSelectedItem() && jComboBoxBlack.getSelectedItem() != null) {
      JOptionPane.showMessageDialog(this, "En spelare kan inte mta sig sjlv.", "Kan inte placera spelare", JOptionPane.INFORMATION_MESSAGE);
      return;
    }
    try {
      // First remove the game from the previous players
			Player white = game.getWhitePlayer();
      if (white != null) {
        white.remove(game);
      }
			Player black = game.getBlackPlayer();
      if (black != null) {
        black.remove(game);
      }
      // Set new players to the game
      white = (Player)jComboBoxWhite.getSelectedItem();
      black = (Player)jComboBoxBlack.getSelectedItem();
      game.setWhitePlayer(white);
      if (white != null) {
        white.add(game);
      }
      game.setBlackPlayer(black);
      if (black != null) {
        black.add(game);
      }
      if (white != null && white.getLotNr() == Integer.MAX_VALUE) {
        // White has no lot nr. Give him a lotnr
        white.setLotNr(game.getGames().getTournament().getPlayers().getNextLotNr());
      }
      if (black != null && black.getLotNr() == Integer.MAX_VALUE) {
        // Black has no lot nr. Give him a lotnr
        black.setLotNr(game.getGames().getTournament().getPlayers().getNextLotNr());
      }
      game.update();
      this.setVisible(false);
    }
    catch (ChessPairerException f) {
      JOptionPane.showMessageDialog(this, f.getMessage(), "Kan inte bordsplacera spelare.", JOptionPane.ERROR_MESSAGE);
    }
    catch (SQLException f) {
      JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
  }

  public class ComboBoxSorterModel extends DefaultComboBoxModel {

    public void addElement(Object object) {
      if (object != null) {
        for (int i = 0; i < this.getSize(); i++) {
          Object obj = getElementAt(i);
          if (obj != null && (obj.toString()).compareTo(object.toString()) > 0) {
            insertElementAt(object, i);
            return;
          }
        }
      }
      super.addElement(object);
    }
  }

}
