package cp.gui;

import cp.ChessPairerException;
import cp.Game;
import cp.Result;
import cp.Round;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.print.*;
import java.sql.SQLException;
import java.text.MessageFormat;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;
import javax.swing.table.*;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;

public class EditResultsPanel extends JScrollPane {
	private EditResultsTableModel editResultsTableModel;
	private JTable jTable, jPrintTable;
	private JPopupMenu jPopupMenu = new JPopupMenu();
	private JMenuItem jMenuItemNotPlayed = new JMenuItem();
	private JMenuItem jMenuItemWhiteWin = new JMenuItem();
	private JMenuItem jMenuItemDraw = new JMenuItem();
	private JMenuItem jMenuItemBlackWin = new JMenuItem();
	private JMenu jMenu = new JMenu();
	private JMenuItem jMenuItemWhiteWinWO = new JMenuItem();
	private JMenuItem jMenuItemBlackWinWO = new JMenuItem();
	private JMenuItem jMenuItemDoubleWO = new JMenuItem();
	private JMenuItem jMenuItemPostponed = new JMenuItem();
	private JMenuItem jMenuItemCanceled = new JMenuItem();
	private JMenuItem jMenuItemEditResult = new JMenuItem();
	private MainFrame mainFrame;
	private ResultDlg resultDlg;

	public EditResultsPanel(MainFrame mainFrame) {
		this.mainFrame = mainFrame;
		try {
			editResultsTableModel = new EditResultsTableModel();
			jTable = new JTable(editResultsTableModel);
			jPrintTable = new JTable(editResultsTableModel);
			jbInit();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void setRound(Round round) {
		editResultsTableModel.setRound(round);
	}

	public Round getRound() {
		return editResultsTableModel.getRound();
	}

	private void jbInit() throws Exception {
		this.setViewportView(jTable);
		jTable.setFillsViewportHeight(true);
		setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		this.addComponentListener(new ComponentAdapter() {
			public void componentShown(ComponentEvent e) {
				this_componentShown();
			}
		});
		jPopupMenu.add(jMenuItemNotPlayed);
		jPopupMenu.add(jMenuItemWhiteWin);
		jPopupMenu.add(jMenuItemDraw);
		jPopupMenu.add(jMenuItemBlackWin);
		jMenu.add(jMenuItemWhiteWinWO);
		jMenu.add(jMenuItemBlackWinWO);
		jMenu.add(jMenuItemDoubleWO);
		jPopupMenu.add(jMenu);
		jPopupMenu.add(jMenuItemPostponed);
		jPopupMenu.add(jMenuItemCanceled);
		jPopupMenu.add(jMenuItemEditResult);
		jTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jTable.setRowSelectionAllowed(true);
		jTable.setColumnSelectionAllowed(false);
		jTable.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				jTable_keyTyped(e);
			}

			public void keyPressed(KeyEvent e) {
				jTable_keyPressed(e);
			}
		});
		jTable.setShowGrid(false);
		jTable.setShowHorizontalLines(true);
		jPrintTable.setShowGrid(false);
		jPrintTable.setShowHorizontalLines(true);
		jPopupMenu.setLabel("jPopupMenu1");
		jMenuItemNotPlayed.setText("Ej spelad");
		jMenuItemNotPlayed.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuItemNotPlayed_actionPerformed();
			}
		});
		jMenuItemWhiteWin.setText("Vit vinst");
		jMenuItemWhiteWin.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuItemWhiteWin_actionPerformed();
			}
		});
		jMenuItemDraw.setText("Remi");
		jMenuItemDraw.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuItemDraw_actionPerformed();
			}
		});
		jMenuItemBlackWin.setText("Svart vinst");
		jMenuItemBlackWin.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuItemBlackWin_actionPerformed();
			}
		});
		jMenu.setText("Walk over");
		jMenuItemWhiteWinWO.setText("Vit vinst");
		jMenuItemWhiteWinWO.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuItemWhiteWinWO_actionPerformed();
			}
		});
		jMenuItemBlackWinWO.setText("Svart vinst");
		jMenuItemBlackWinWO.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuItemBlackWinWO_actionPerformed();
			}
		});
		jMenuItemDoubleWO.setText("Dubbel wo");
		jMenuItemDoubleWO.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuItemDoubleWO_actionPerformed();
			}
		});
		jMenuItemPostponed.setText("Uppskjuten");
		jMenuItemPostponed.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuItemPostponed_actionPerformed();
			}
		});
		jMenuItemCanceled.setText("Instlld");
		jMenuItemCanceled.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuItemCanceled_actionPerformed();
			}
		});
		jMenuItemEditResult.setText("Editera pong");
		jMenuItemEditResult.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuItemEditResult_actionPerformed();
			}
		});
		MouseListener popupListener = new PopupListener();
		jTable.addMouseListener(popupListener);
		jTable.addMouseListener(new EditResultsPanel_jTable_mouseAdapter(this));
		resultDlg = new ResultDlg();
		resultDlg.setLocationRelativeTo(this);
	}

	private void jTable_keyTyped(KeyEvent e) {
		int row = jTable.getSelectedRow();
		if (row > -1) {
			try {
				Result result = (Result) editResultsTableModel.getValueAt(row, editResultsTableModel.getResultColumn());
				int pointsPerGame;
				if (mainFrame.getSettings().getMaxPointsImmediately()) {
					pointsPerGame = result.getPointsPerGame();
				}
				else {
					pointsPerGame = 1;
				}
				if (e.getKeyChar() == '0' || e.getKeyChar() == 'f' || e.getKeyChar() == 'F') {
					result.addBlackScore(pointsPerGame);
				}
				else if (e.getKeyChar() == '' || e.getKeyChar() == 'r' || e.getKeyChar() == 'R') {
					result.addWhiteScore(0.5);
					result.addBlackScore(pointsPerGame - 0.5);
				}
				else if (e.getKeyChar() == '1' || e.getKeyChar() == 'v' || e.getKeyChar() == 'V') {
					result.addWhiteScore(1);
					result.addBlackScore(pointsPerGame - 1);
				}
				else if (e.getKeyChar() == '2') {
					result.addWhiteScore(2);
					result.addBlackScore(pointsPerGame - 2);
				}
				else if (e.getKeyChar() == '3') {
					result.addWhiteScore(3);
					result.addBlackScore(pointsPerGame - 3);
				}
				else if (e.getKeyChar() == '4') {
					result.addWhiteScore(4);
					result.addBlackScore(pointsPerGame - 4);
				}
				else if (e.getKeyChar() == '5') {
					result.addWhiteScore(1);
					result.addBlackScore(pointsPerGame - 5);
				}
				else if (e.getKeyChar() == ' ') {
					result.setResultType(Result.ResultType.NO_RESULT);
				}
				result.getGame().update();
				editResultsTableModel.fireTableDataChanged();
				if (row + 1 < jTable.getRowCount() && result.isFinished()) {
					jTable.setRowSelectionInterval(row + 1, row + 1);
					jTable.scrollRectToVisible(jTable.getCellRect(row + 1, 0, true));
				}
				else {
					jTable.setRowSelectionInterval(row, row);
				}
			}
			catch (ChessPairerException f) {
				JOptionPane.showMessageDialog(this, f.getMessage(), "Kan ej stta resultat", JOptionPane.INFORMATION_MESSAGE);
			}
			catch (SQLException f) {
				JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
				System.exit(0);
			}
		}
	}

	private void jTable_keyPressed(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_DELETE) {
			deleteSelectedPair();
		}
	}

	public void deleteSelectedPair() {
		int row = jTable.getSelectedRow();
		if (row > -1) {
			if (JOptionPane.showConfirmDialog(this, String.format("r du sker p att du vill ta bort bord %d?", row + 1), "Radera bord", JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE) == JOptionPane.OK_OPTION) {
				try {
					editResultsTableModel.delete(row);
					editResultsTableModel.fireTableDataChanged();
					if (row > 0) {
						jTable.setRowSelectionInterval(row - 1, row - 1);
					}
				}
				catch (SQLException f) {
					JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
				}
			}
		}
	}

	private void jMenuItemNotPlayed_actionPerformed() {
		setResultTypeToMarkedGame(Result.ResultType.NO_RESULT);
	}

	private void jMenuItemWhiteWin_actionPerformed() {
		setResultTypeToMarkedGame(Result.ResultType.WHITE_WIN);
	}

	private void setResultTypeToMarkedGame(Result.ResultType resultType) {
		int row = jTable.getSelectedRow();
		if (row > -1) {
			try {
				Result result = (Result) editResultsTableModel.getValueAt(row, editResultsTableModel.getResultColumn());
				result.setResultType(resultType);
				result.getGame().update();
				editResultsTableModel.fireTableDataChanged();
				jTable.setRowSelectionInterval(row, row);
			}
			catch (ChessPairerException e) {
				JOptionPane.showMessageDialog(this, e.getMessage(), "Information", JOptionPane.INFORMATION_MESSAGE);
			}
			catch (SQLException f) {
				JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
				System.exit(0);
			}
		}
	}

	private void jMenuItemDraw_actionPerformed() {
		setResultTypeToMarkedGame(Result.ResultType.DRAW);
	}

	private void jMenuItemBlackWin_actionPerformed() {
		setResultTypeToMarkedGame(Result.ResultType.BLACK_WIN);
	}

	private void jMenuItemPostponed_actionPerformed() {
		setResultTypeToMarkedGame(Result.ResultType.POSTPONED);
	}

	private void jMenuItemCanceled_actionPerformed() {
		setResultTypeToMarkedGame(Result.ResultType.CANCELLED);
	}

	private void jMenuItemWhiteWinWO_actionPerformed() {
		setResultTypeToMarkedGame(Result.ResultType.WHITE_WIN_WO);
	}

	private void jMenuItemBlackWinWO_actionPerformed() {
		setResultTypeToMarkedGame(Result.ResultType.BLACK_WIN_WO);
	}

	private void jMenuItemDoubleWO_actionPerformed() {
		setResultTypeToMarkedGame(Result.ResultType.DOUBLE_WO);
	}

	private void jMenuItemEditResult_actionPerformed() {
		resultDlg.set(getGame());
		resultDlg.setVisible(true);
		editResultsTableModel.fireTableDataChanged();
	}

	public Game appendPair() throws SQLException, ChessPairerException {
		Game game = editResultsTableModel.appendPair();
		editResultsTableModel.fireTableDataChanged();
		return game;
	}

	public Game getGame() {
		int row = jTable.getSelectedRow();
		if (row > -1) {
			return editResultsTableModel.getGame(row);
		}
		return null;
	}

	void jTable_mouseClicked(MouseEvent e) {
		if (e.getClickCount() > 1) {
			mainFrame.jMenuItemEditPair_actionPerformed();
			repaint();
		}
	}

	public void print() throws PrinterException {
		update();
		Round round = editResultsTableModel.getRound();
		if (round != null) {
			MessageFormat headerFormat = new MessageFormat(String.format("Lottning fr rond %d", round.getRoundNr()));
			MessageFormat footerFormat = new MessageFormat(String.format("%s, grupp %s\n     - Sida {0} -", round.getTournament(), round.getTournament().getGroup()));
			optimizeTableWidth(jPrintTable);
			jPrintTable.print(JTable.PrintMode.FIT_WIDTH, headerFormat, footerFormat);
		}
	}

	public static void optimizeTableWidth(JTable table) {
		for (int i = 0; i < table.getColumnCount(); i++) {
			DefaultTableColumnModel colModel = (DefaultTableColumnModel) table.getColumnModel();
			TableColumn col = colModel.getColumn(i);
			int width = 0;
			TableCellRenderer renderer = col.getHeaderRenderer();
			for (int r = 0; r < table.getRowCount(); r++) {
				renderer = table.getCellRenderer(r, i);
				Component comp = renderer.getTableCellRendererComponent(table, table.getValueAt(r, i), false, false, r, i);
				width = Math.max(width, comp.getPreferredSize().width);
			}
			TableColumn tc = table.getColumnModel().getColumn(i);
			width = Math.max(width, tc.getPreferredWidth());
			col.setPreferredWidth(width + 2);
			col.setWidth(width + 2);
		}

		table.setSize(table.getPreferredSize());
		JTableHeader header = table.getTableHeader();
		header.setSize(header.getPreferredSize());
	}

	public void save(Document document, Element body) {
		// Insert table
		Element table = document.createElement("table");
		body.appendChild(table);
		table.setAttribute("class", "CP_TableResults");
		table.setAttribute("cellpadding", "0");
		table.setAttribute("cellspacing", "0");
		table.setAttribute("border", "0");
		// Create headers
		Element tr = document.createElement("tr");
		table.appendChild(tr);
		tr.setAttribute("class", "CP_TableResultsHeader");
		for (int i = 0; i < editResultsTableModel.getColumnCount(); i++) {
			Element th = document.createElement("th");
			tr.appendChild(th);
			String colName = editResultsTableModel.getColumnName(i);
			th.setAttribute("class", String.format("CP_TableResultsHeaderC%s", colName.replace(" ", "")));
			Text text = document.createTextNode(editResultsTableModel.getColumnName(i));
			th.appendChild(text);
		}
		for (int i = 0; i < editResultsTableModel.getRowCount(); i++) {
			tr = document.createElement("tr");
			table.appendChild(tr);
			tr.setAttribute("class", "CP_TableResultsRow");
			for (int j = 0; j < editResultsTableModel.getColumnCount(); j++) {
				Element th = document.createElement("th");
				tr.appendChild(th);
				String colName = editResultsTableModel.getColumnName(j);
				th.setAttribute("class", String.format("CP_TableResultsC%s", colName.replace(" ", "")));
				Object obj = editResultsTableModel.getValueAt(i, j);
				if (obj != null) {
					Text text = document.createTextNode(obj.toString());
					th.appendChild(text);
				}
			}
		}
	}

	public void update() {
		if (editResultsTableModel != null) {
			editResultsTableModel.update();
			setColumnWidths();
		}
		jTable.doLayout();
		jTable.repaint();
	}

	private void setColumnWidths() {
		setColumnWidths(jTable);
		setColumnWidths(jPrintTable);
	}

	private void setColumnWidths(JTable table) {
		TableColumn column = null;
		for (int i = 0; i < table.getColumnCount(); i++) {
			column = table.getColumnModel().getColumn(i);
			if (table.getColumnName(i).equalsIgnoreCase("Bord")) {
				column.setPreferredWidth(30);
			}
			else if (table.getColumnName(i).equalsIgnoreCase("Nr")) {
				column.setPreferredWidth(25);
			}
			else if (table.getColumnName(i).contains("spelare")) {
				column.setPreferredWidth(150);
			}
			else if (table.getColumnName(i).equalsIgnoreCase("Rating")) {
				column.setPreferredWidth(40);
			}
			else if (table.getColumnName(i).equalsIgnoreCase("ELO")) {
				column.setPreferredWidth(30);
			}
			else if (table.getColumnName(i).equalsIgnoreCase("Resultat")) {
				column.setPreferredWidth(50);
			}
		}
	}

	private void this_componentShown() {
		update();
	}

	void scrollRectToVisible() {
		jTable.scrollRectToVisible(jTable.getCellRect(editResultsTableModel.getRowCount(), 0, true));
	}

	class PopupListener extends MouseAdapter {
		public void mousePressed(MouseEvent e) {
			maybeShowPopup(e);
		}

		public void mouseReleased(MouseEvent e) {
			maybeShowPopup(e);
		}

		private void maybeShowPopup(MouseEvent e) {
			if (e.isPopupTrigger()) {
				int row = jTable.getSelectedRow();
				if (row > -1) {
					jPopupMenu.show(e.getComponent(), e.getX(), e.getY());
				}
			}
		}
	}

	private class EditResultsPanel_jTable_mouseAdapter extends MouseAdapter {
		private EditResultsPanel adaptee;

		EditResultsPanel_jTable_mouseAdapter(EditResultsPanel adaptee) {
			this.adaptee = adaptee;
		}

		public void mouseClicked(MouseEvent e) {
			adaptee.jTable_mouseClicked(e);
		}
	}
}
