package cp.gui;

import cp.tiebreak.Tiebreak;
import cp.tiebreak.Tiebreaks;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.ListSelectionModel;
import javax.swing.border.EtchedBorder;

public class TournamentDialogTiebreak extends JPanel {
  private JPanel jPanel3 = new JPanel();
  private GridBagLayout gridBagLayout1 = new GridBagLayout();
  private JList availableTiebreaksList = new JList();
  private JList selectedTiebreaksList = new JList();
  private JLabel jLabel11 = new JLabel();
  private JLabel jLabel14 = new JLabel();
  private GridBagLayout gridBagLayout2 = new GridBagLayout();
  private JButton jButtonAdd = new JButton();
  private JButton jButtonRemove = new JButton();
  private JPanel jPanel2 = new JPanel();
  private JButton jButtonUp = new JButton();
  private JButton jButtonDown = new JButton();

  public TournamentDialogTiebreak() {
    try {
      jbInit();
      this.setTiebreaks(new Tiebreaks());
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setLayout(gridBagLayout2);
    jPanel3.setLayout(gridBagLayout1);
    availableTiebreaksList.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
    availableTiebreaksList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    selectedTiebreaksList.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
    selectedTiebreaksList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jPanel3.add(availableTiebreaksList, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
          new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(selectedTiebreaksList, new GridBagConstraints(2, 1, 1, 1, 0.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0),
          0, 0));
    jPanel3.add(jLabel11, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(jLabel14, new GridBagConstraints(2, 0, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(jButtonAdd, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 30, 5), 0, 0));
    jPanel3.add(jButtonRemove, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(30, 5, 0, 5), 0,
          0));
    jPanel2.add(jButtonUp, null);
    jPanel2.add(jButtonDown, null);
    jPanel3.add(jPanel2, new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    this.add(jPanel3, new GridBagConstraints(0, 0, 1, 3, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    selectedTiebreaksList.setModel(new DefaultListModel());
    jLabel11.setText("Valbara");
    jLabel14.setText("Valda");
    jButtonRemove.setToolTipText("Ta bort srskiljning");
    jButtonRemove.setMargin(new Insets(1, 7, 1, 7));
    jButtonAdd.setText(">>");
    jButtonAdd.setMargin(new Insets(1, 7, 1, 7));
    jButtonAdd.setToolTipText("Lgg till srskiljning");
    jButtonAdd.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonAdd_actionPerformed(e);
        }
      });
    jButtonRemove.setText("<<");
    jButtonRemove.setMargin(new Insets(1, 7, 1, 7));
    jButtonRemove.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonRemove_actionPerformed(e);
        }
      });
    jButtonUp.setText("Upp");
    jButtonUp.setMargin(new Insets(1, 7, 1, 7));
    jButtonUp.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonUp_actionPerformed(e);
        }
      });
    jButtonDown.setText("Ner");
    jButtonDown.setMargin(new Insets(1, 7, 1, 7));
    jButtonDown.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonDown_actionPerformed(e);
        }
      });
    selectedTiebreaksList.setModel(new DefaultListModel());
    availableTiebreaksList.setModel(new DefaultListModel());
  }
  
  protected void setTiebreaks(Tiebreaks tiebreaks) {
    Vector<Tiebreak> available = tiebreaks.getAvailableTiebreaks();
    DefaultListModel model = (DefaultListModel)availableTiebreaksList.getModel();
    model.clear();
    for (int i=0; i<available.size(); i++) {
      Tiebreak tiebreak = available.get(i);
      if (!tiebreak.toString().equals("Random")) {
        model.addElement(available.get(i));
      }
    }
    Vector<Tiebreak> selected = tiebreaks.getSelectedTiebreaks();
    model = (DefaultListModel)selectedTiebreaksList.getModel();
    model.clear();
    for (int i=0; i<selected.size(); i++) {
      model.addElement(selected.get(i));
    }
  }

  protected Tiebreaks getTiebreaks() {
    Tiebreaks tiebreaks = new Tiebreaks();
    DefaultListModel model = (DefaultListModel)selectedTiebreaksList.getModel();
    for (int i=0; i<model.size(); i++) {
      tiebreaks.select(model.get(i).toString());
    }
    return tiebreaks;
  }

  private void jButtonAdd_actionPerformed(ActionEvent e) {
    Tiebreak tiebreak = (Tiebreak) availableTiebreaksList.getSelectedValue();
    if (tiebreak != null) {
      DefaultListModel model = (DefaultListModel)selectedTiebreaksList.getModel();
      model.addElement(tiebreak);
      model = (DefaultListModel) availableTiebreaksList.getModel();
      model.removeElement(tiebreak);
    }
  }

  private void jButtonRemove_actionPerformed(ActionEvent e) {
    Tiebreak tiebreak = (Tiebreak) selectedTiebreaksList.getSelectedValue();
    if (tiebreak != null) {
      DefaultListModel model = (DefaultListModel)selectedTiebreaksList.getModel();
      model.removeElement(tiebreak);
      model = (DefaultListModel) availableTiebreaksList.getModel();
      model.addElement(tiebreak);
    }
  }

  private void jButtonUp_actionPerformed(ActionEvent e) {
    Tiebreak tiebreak = (Tiebreak) selectedTiebreaksList.getSelectedValue();
    if (tiebreak != null) {
      DefaultListModel model = (DefaultListModel) selectedTiebreaksList.getModel();
      int idx = model.indexOf(tiebreak);
      if (idx > 0) {
        model.remove(idx);
        model.add(idx-1, tiebreak);
      }
    }
  }

  private void jButtonDown_actionPerformed(ActionEvent e) {
    Tiebreak tiebreak = (Tiebreak) selectedTiebreaksList.getSelectedValue();
    if (tiebreak != null) {
      DefaultListModel model = (DefaultListModel) selectedTiebreaksList.getModel();
      int idx = model.indexOf(tiebreak);
      if (idx < model.size()-1) {
        model.remove(idx);
        model.add(idx+1, tiebreak);
      }
    }
  }
}
