package cp.gui;

import cp.Player;
import cp.Players;
import cp.Tournament;
import cp.db.Settings;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.sql.SQLException;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ScrollPaneConstants;

public class TournamentPlayersDialog extends JDialog implements PlayerEditor {
	private EditPlayerPanel editPlayerPanel = new EditPlayerPanel();
	private JScrollPane jScrollPane = new JScrollPane();
	private GridBagLayout gridBagLayout1 = new GridBagLayout();
	private JPanel jPanelList = new JPanel();
	private JButton jButtonDelete = new JButton();
	private JLabel jLabel5 = new JLabel();
	private JScrollPane jScrollPane1 = new JScrollPane();
	private JLabel jLabel6 = new JLabel();
	private JPanel jPanel2 = new JPanel();
	private JButton jButtonAddPlayer = new JButton();
	private FlowLayout flowLayout2 = new FlowLayout();
	private JLabel jLabelRegistered = new JLabel();
	private JLabel jLabelStatus = new JLabel();
	private JButton jButtonClose = new JButton();

	private PlayerListTableModel availableTableModel;
	private PlayerListTableModel tournamentTableModel;
	private JTable jTableAvailablePlayers;
	private JTable jTableTournamentPlayers;
	private Settings settings;
	private Tournament tournament;

	public TournamentPlayersDialog(Settings settings, Image icon) {
		this.settings = settings;
	  availableTableModel = new PlayerListTableModel();
	  tournamentTableModel = new PlayerListTableModel();
	  jTableAvailablePlayers = new JTable(availableTableModel);
	  jTableTournamentPlayers = new JTable(tournamentTableModel);

    this.setIconImage(icon);
		try {
			jbInit();
		  editPlayerPanel.init(settings, this);
		  this.getRootPane().setDefaultButton(editPlayerPanel.getDefaultButton());
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

  public void setVisible(boolean value) {
    editPlayerPanel.updateClubList();
    if (value) {
      update();
    }
    super.setVisible(value);
  }

	void setTournament(Tournament tournament) throws SQLException {
		this.tournament = tournament;
		this.setTitle("Editera turneringsspelare i turnering " + tournament);
		loadAvailablePlayers();
		loadTournamentPlayers();
	}

	private void jbInit() throws Exception {
		this.getContentPane().setLayout(gridBagLayout1);
		this.setModal(true);
	  this.setResizable(true);
    jScrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		jScrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
		jScrollPane.setPreferredSize(new Dimension(480, 12));
		jButtonDelete.setText("Ta bort");
		jButtonDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jButtonDelete_actionPerformed();
			}
		});
		jLabel5.setText("Spelarpool");
		jLabel5.setFont(new Font("Tahoma", 1, 11));
		jTableAvailablePlayers.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				jListAvailablePlayers_mouseClicked(e);
			}
		});
		jScrollPane.getViewport().add(jTableAvailablePlayers, null);
		this.getContentPane().add(jScrollPane, new GridBagConstraints(3, 1, 1, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
		jPanelList.add(jButtonDelete, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 5, 0), 0, 0));
		this.getContentPane().add(jPanelList, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		this.getContentPane().add(jLabel5, new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		jScrollPane1.getViewport().add(jTableTournamentPlayers, null);
		this.getContentPane().add(jScrollPane1, new GridBagConstraints(1, 1, 1, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
	  this.getContentPane().add(editPlayerPanel, new GridBagConstraints(0, 0, 1, 4, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.BOTH, new Insets(0, 5, 0, 5), 0, 0));
		this.getContentPane().add(jLabel6, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		jPanel2.add(jButtonAddPlayer, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 10, 10, 10), 0, 0));
		this.getContentPane().add(jPanel2, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 2, 0, 2), 0, 0));
		this.getContentPane().add(jLabelRegistered, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		this.getContentPane().add(jLabelStatus, new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		this.getContentPane().add(jButtonClose, new GridBagConstraints(3, 3, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 8), 0, 0));

		jScrollPane1.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		jScrollPane1.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
		jScrollPane1.setPreferredSize(new Dimension(480, 12));

		jTableTournamentPlayers.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				jButtonEdit_actionPerformed();
			}
		});
		jButtonClose.setText("Stng");
		jButtonClose.setMargin(new Insets(1, 7, 1, 7));
		jButtonClose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jButtonClose_actionPerformed();
			}
		});
		jLabel6.setText("Turneringsspelare");
		jLabel6.setFont(new Font("Tahoma", 1, 11));
		jPanel2.setLayout(flowLayout2);
		jPanel2.setPreferredSize(new Dimension(26, 64));
		jButtonAddPlayer.setText("<-");
		jButtonAddPlayer.setMargin(new Insets(1, 1, 1, 1));
    jButtonAddPlayer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jButtonAddPlayer_actionPerformed();
			}
		});
		jLabelRegistered.setText("Inga spelare registrerade i turneringen.");
		pack();
	}

	private void loadAvailablePlayers() throws SQLException {
		Players players = new Players(settings);
		players.load();
		availableTableModel.setPlayers(players);
	}

	private void loadTournamentPlayers() throws SQLException {
		Players players = tournament.getPlayers();
		tournamentTableModel.setPlayers(players);
		jLabelRegistered.setText(String.format("%d spelare registrerade i turneringen.", players.size()));
	}

	private void jButtonClose_actionPerformed() {
		this.setVisible(false);
	}

	private void jButtonEdit_actionPerformed() {
		int row = jTableTournamentPlayers.getSelectedRow();
		if (row > -1) {
			Player player = tournamentTableModel.getPlayer(row);
			if (player != null) {
				editPlayerPanel.setPlayer(player);
			}
		}
	}

	private void jButtonDelete_actionPerformed() {
		int[] rows = jTableTournamentPlayers.getSelectedRows();
		if (rows.length > 0) {
			if (JOptionPane.showConfirmDialog(this, "r du sker p att du vill ta bort valda spelare frn turneringen?", "Bekrfta ta bort spelare", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) == JOptionPane.OK_OPTION) {
				try {
					for (int i = rows.length - 1; i >= 0; i--) {
						Player player = tournamentTableModel.getPlayer(rows[i]);
						tournament.remove(player);
					}
				}
				catch (SQLException f) {
					if (f.getMessage().contains("foreign key constraint")) {
						JOptionPane.showMessageDialog(this, "Du kan inte ta bort en spelare som har blivit inlottad i en turnering. Anvnd 'Utg frn rond' istllet.", "Information", JOptionPane.INFORMATION_MESSAGE);
					}
					else {
						JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
					}
				}
				update();
				jLabelRegistered.setText(String.format("%d spelare registrerade i turneringen.", tournament.getPlayers().size()));
				jLabelStatus.setText("");
				editPlayerPanel.setPlayer(null);
			  jTableTournamentPlayers.clearSelection();

			}
		}
	}

	private void jListAvailablePlayers_mouseClicked(MouseEvent e) {
		if (e.getClickCount() > 1) {
			jButtonAddPlayer_actionPerformed();
		}
	}

	private void jButtonAddPlayer_actionPerformed() {
		int[] rows = jTableAvailablePlayers.getSelectedRows();
		if (rows.length > 0) {
			for (int i = 0; i < rows.length; i++) {
				Player player = availableTableModel.getPlayer(rows[i]);
				try {
				  Player clone = new Player(player);
				  clone.setTournament(tournament);
				  tournament.add(clone);
				}
				catch (SQLException f) {
					if (f.getMessage().contains("duplicate key value")) {
						JOptionPane.showMessageDialog(this, "Spelare " + player + " finns redan i turneringen.", "Duplicate player", JOptionPane.WARNING_MESSAGE);
					}
					else {
						JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
					}
				}
      }
			update();
			jLabelRegistered.setText(String.format("%d spelare registrerade i turneringen.", tournament.getPlayers().size()));
			if (rows.length > 0) {
				jLabelStatus.setText(String.format("Lade till %d spelare till turneringen.", rows.length));
			}
			else {
				jLabelStatus.setText("Ingen spelare vald.");
			}
		}
	}

	public void add(Player player) throws SQLException {
		tournament.add(player);
	  update();
		jLabelRegistered.setText(String.format("%d spelare registrerade i turneringen.", tournament.getPlayers().size()));
		jLabelStatus.setText("");
	}

	public void update(Player player) throws SQLException {
		tournament.update(player);
		update();
	  jTableTournamentPlayers.clearSelection();
		jLabelRegistered.setText(String.format("%d spelare registrerade i turneringen.", tournament.getPlayers().size()));
		jLabelStatus.setText("");
	}

	public boolean showTournamentInfo() {
		return true;
	}

  void update() {
    if (availableTableModel != null) {
      availableTableModel.update();
      availableTableModel.setColumnWidths(jTableAvailablePlayers);
    }
    jTableAvailablePlayers.doLayout();
    jTableAvailablePlayers.repaint();

    if (tournamentTableModel != null) {
      tournamentTableModel.update();
      tournamentTableModel.setColumnWidths(jTableTournamentPlayers);
    }
    jTableTournamentPlayers.doLayout();
    jTableTournamentPlayers.repaint();
  }
  
  public Tournament getTournament() {
    return tournament;
  }
}
