package cp.tiebreak;

import cp.Game;
import cp.Player;
import cp.Round;

import java.util.Vector;

public class TiebreakBerger implements Tiebreak {
  
  /**
   * Calculates the tiebreak score for a player up to a given round.
   * 
   */
  public double getTiebreak(Round round, Player player) {
    double tiebreak = 0;
    Vector games = player.getGames();
    int roundNr = round.getRoundNr();
    for (int i = 0; i < games.size(); i++) {
      Game game = (Game)games.get(i);     
      if (game.getRoundNr() <= roundNr) {
        if (!game.plays(null) && game.getResult().isPlayed()) {
          Player white = game.getWhitePlayer();
          Player black = game.getBlackPlayer();
          if (white == player) {
            tiebreak += black.getPairingScore(round) * game.getPairingScore(white, roundNr);
          }
          else if (black == player) {
            tiebreak += white.getPairingScore(round) * game.getPairingScore(black, roundNr);
          }
        }
      }
    }
    return tiebreak;
  }
  
  public String toString() {
    return "Berger";
  }

  public String getShortName() {
    return "Berg";
  }

  public String format(double value) {
    return Double.toString(value);
  }
  
}
