package cp.tiebreak;

import cp.Game;
import cp.Games;
import cp.Player;
import cp.Round;
import cp.Rounds;

import java.util.Vector;

public class TiebreakProgressive implements Tiebreak {
  
  /**
   * Calculates the tiebreak score for a player up to a given round.
   * 
   */
  public double getTiebreak(Round round, Player player) {
    double tiebreak = 0;
    Vector games = player.getGames();
    for (int i = 0; i < games.size(); i++) {
      Game game = (Game)games.get(i);
      int roundNr = game.getRoundNr();
      if (game.getRoundNr() <= round.getRoundNr()) {
        int multiplier = round.getRoundNr() - roundNr + 1;
        tiebreak += multiplier * game.getScore(player, roundNr);
      }
    }
    return tiebreak;
  }
  
  public String toString() {
    return "Progressiv";
  }

  public String getShortName() {
    return "Prog";
  }
  
  public String format(double value) {
    return Double.toString(value);
  }

}
